bd9343babbdba455cff0176a745a63894739ba44
[xfstests-dev.git] / common.config
1 ##/bin/sh
2 #
3 # Copyright (c) 2000-2003 Silicon Graphics, Inc.  All Rights Reserved.
4
5 # This program is free software; you can redistribute it and/or modify it
6 # under the terms of version 2 of the GNU General Public License as
7 # published by the Free Software Foundation.
8
9 # This program is distributed in the hope that it would be useful, but
10 # WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
12
13 # Further, this software is distributed without any warranty that it is
14 # free of the rightful claim of any third person regarding infringement
15 # or the like.  Any license provided herein, whether implied or
16 # otherwise, applies only to this software file.  Patent licenses, if
17 # any, provided herein do not apply to combinations of this program with
18 # other software, or any other product whatsoever.
19
20 # You should have received a copy of the GNU General Public License along
21 # with this program; if not, write the Free Software Foundation, Inc., 59
22 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
23
24 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
25 # Mountain View, CA  94043, or:
26
27 # http://www.sgi.com 
28
29 # For further information regarding this notice, see: 
30
31 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
32 #
33
34 #
35 # setup and check for config parameters, and in particular
36 #
37 # TEST_DIR              - scratch test directory that is in an already
38 #                         mounted XFS file system, needs to be be world
39 #                         writeable
40 # TEST_DEV              - device for file system containing TEST_DIR
41 # SCRATCH_DEV           - device you can make a scratch file system on
42 # SCRATCH_MNT           - mount point for scratch file system
43
44 # and optionally:
45 # SCRATCH_LOGDEV        - scratch log device for external log testing
46 # SCRATCH_RTDEV         - scratch rt dev
47 # TEST_LOGDEV           - test log device for external log testing
48 # TEST_RTDEV            - test rt dev
49 # TAPE_DEV              - the tape device for the xfsdump tests
50 # RMT_TAPE_DEV          - the remote tape device for the xfsdump tests
51 # RMT_IRIXTAPE_DEV      - the IRIX remote tape device for the xfsdump tests
52 # RMT_TAPE_USER         - remote user for tape device
53 #
54 # - These can be added to known_hosts() below or a separate local
55 #   configuration file can be used (using the HOST_OPTIONS variable).
56 # - This script is shared by the stress test system and the auto-qa
57 #   system (includes both regression test and benchmark components).
58 # - TEST_DEV & TEST_DIR must be assigned.
59 # - this script shouldn't make any assertions about filesystem
60 #   validity or mountedness.
61 #
62
63 # Warning: don't put freeware before /usr/bsd on IRIX coz you'll
64 #          get the wrong hostname and set your system name to -s  :)
65 [ -d /usr/bsd ] && PATH=$PATH:/usr/bsd
66 [ -d /usr/freeware/bin ] && PATH=$PATH:/usr/freeware/bin
67 PATH=".:$PATH"
68
69 HOST=`hostname -s`
70 HOSTOS=`uname -s`
71 [ "$HOSTOS" = "IRIX64" ] && HOSTOS="IRIX"
72
73 MODULAR=0               # using XFS as a module or not
74 BOOT="/boot"            # install target for kernels
75 export EXTRA=${EXTRA:=xfs-qa}
76
77 MAKE=make
78 [ "$HOSTOS" == "IRIX" ] && MAKE=gmake
79
80 # general parameters (mainly for auto-qa)
81 SOAK_PROC=3             # -p option to fsstress
82 SOAK_STRESS=10000       # -n option to fsstress
83 SOAK_PASSES=-1          # count of repetitions of fsstress (while soaking)
84 EMAIL=root@localhost    # where auto-qa will send its status messages
85 export HOST_OPTIONS=${HOST_OPTIONS:=local.config}
86 export CHECK_OPTIONS=${CHECK_OPTIONS:="-g auto"}
87 export BENCH_PASSES=${BENCH_PASSES:=5}
88 export XFS_MKFS_OPTIONS=${XFS_MKFS_OPTIONS:=-bsize=4096}
89
90 #export DEBUG=${DEBUG:=...} # arbitrary CFLAGS really.
91 export MALLOCLIB=${MALLOCLIB:=/usr/lib/libefence.a}
92 export LOCAL_CONFIGURE_OPTIONS=${LOCAL_CONFIGURE_OPTIONS:=--enable-readline=yes}
93
94 # $1 = prog to look for, $2* = default pathnames if not found in $PATH
95 set_prog_path()
96 {
97     p=`which $1 2> /dev/null`
98     if [ -n "$p" -a -x "$p" ]
99     then
100         echo $p
101         return 0
102     fi
103     p=$1
104
105     shift
106     for f
107     do
108         if [ -x $f ]
109         then
110             echo $f
111             return 0
112         fi
113     done
114
115     echo ""
116     return 1
117 }
118
119 _fatal()
120 {
121     echo "$*"
122     status=1
123     exit 1
124 }
125
126 export MKFS_PROG="`set_prog_path mkfs`"
127 [ "$MKFS_PROG" = "" ] && _fatal "mkfs not found"
128
129 export AWK_PROG="`set_prog_path awk`"
130 [ "$AWK_PROG" = "" ] && _fatal "awk not found"
131
132 export MOUNT_PROG="`set_prog_path mount`"
133 [ "$MOUNT_PROG" = "" ] && _fatal "mount not found"
134
135 export UMOUNT_PROG="`set_prog_path umount`"
136 [ "$UMOUNT_PROG" = "" ] && _fatal "umount not found"
137
138 export NSLOOKUP_PROG="`set_prog_path nslookup`"
139 [ "$NSLOOKUP_PROG" = "" ] && _fatal "nslookup not found"
140
141 export PERL_PROG="`set_prog_path perl`"
142 [ "$PERL_PROG" = "" ] && _fatal "perl not found"
143
144 export SED_PROG="`set_prog_path sed`"
145 [ "$SED_PROG" = "" ] && _fatal "sed not found"
146
147 export MAKE_PROG="`set_prog_path $MAKE`"
148 [ "$MAKE_PROG" = "" ] && _fatal "$MAKE not found"
149
150 export PS_ALL_FLAGS="-ef"
151
152 export DF_PROG="`set_prog_path df`"
153 [ "$DF_PROG" = "" ] && _fatal "df not found"
154 [ "$HOSTOS" = "Linux" ] && export DF_PROG="$DF_PROG -T"
155
156 export XFS_LOGPRINT_PROG="`set_prog_path xfs_logprint`"
157 export XFS_REPAIR_PROG="`set_prog_path xfs_repair`"
158 export XFS_CHECK_PROG="`set_prog_path xfs_check`"
159 export XFS_DB_PROG="`set_prog_path xfs_db`"
160
161 case "$HOSTOS" in
162     IRIX*)
163            export MKFS_XFS_PROG="`set_prog_path mkfs_xfs`"
164            export MKFS_UDF_PROG="`set_prog_path mkfs_udf`" 
165            export XFS_FSR_PROG="`set_prog_path /usr/etc/fsr_xfs`"
166            export MKFS_NFS_PROG="false" 
167            ;;
168     Linux)
169            export MKFS_XFS_PROG="`set_prog_path mkfs.xfs`"
170            export MKFS_UDF_PROG="`set_prog_path mkudffs`"
171            export XFS_FSR_PROG="`set_prog_path xfs_fsr`"
172            export MKFS_NFS_PROG="false" 
173            ;;
174 esac
175
176 known_hosts()
177 {
178         case "$HOST"
179         in
180             bruce)
181                 MODULAR=0
182                 EMAIL="nathans@larry"
183                 SCRATCH_MNT=/mnt/xfs0
184                 SCRATCH_DEV=/dev/sdb5
185                 #SCRATCH_RTDEV=/dev/sdc1
186                 SCRATCH_LOGDEV=/dev/sda11
187                 TEST_DIR=/mnt/xfs1
188                 TEST_DEV=/dev/sdc3
189                 #TEST_RTDEV=/dev/sdb6
190                 TEST_LOGDEV=/dev/sda9
191                 TAPE_DEV=/dev/st0
192                 RMT_TAPE_DEV=bruce:/dev/st0
193                 RMT_IRIXTAPE_DEV=snort:/dev/tape
194                 RMT_TAPE_USER=guest
195                 ;;
196             sherman)
197                 TEST_DEV=/dev/sda10
198                 TEST_DIR=/mnt/xfs1
199                 SCRATCH_DEV=/dev/sda9
200                 SCRATCH_MNT=/mnt/xfs0
201                 ;;
202             flutz)
203                 MODULAR=0
204                 EMAIL="nathans@larry"
205                 TEST_DEV=/dev/sda5
206                 TEST_LOGDEV=/dev/sda9
207                 TEST_DIR=/xfsqa1
208                 SCRATCH_DEV=/dev/sda6
209                 SCRATCH_LOGDEV=/dev/sda7
210                 SCRATCH_MNT=/xfsqa2
211                 TAPE_DEV=/dev/st0
212                 RMT_TAPE_DEV=bruce:/dev/st0
213                 RMT_IRIXTAPE_DEV=snort:/dev/tape
214                 RMT_TAPE_USER=guest
215                 ;;
216             frodo)
217                 MODULAR=0
218                 EMAIL="nathans@larry"
219                 TEST_DEV=/dev/hda6
220                 TEST_DIR=/mnt/test
221                 SCRATCH_DEV=/dev/hda7
222                 SCRATCH_MNT=/mnt/scratch
223                 SCRATCH_LOGDEV=/dev/hda9
224                 ;;
225             goldfish)
226                 MODULAR=0
227                 TEST_DEV=/dev/hdc1
228                 TEST_DIR=/mnt/xfs0
229                 SCRATCH_DEV=/dev/hdc2
230                 SCRATCH_MNT=/mnt/xfs1
231                 SCRATCH_LOGDEV=/dev/hdc3
232                 ;;
233             lord)
234                 TEST_DIR=/xfs
235                 TEST_DEV=/dev/sda1
236                 SCRATCH_DEV=/dev/sda5
237                 SCRATCH_LOGDEV=/dev/sda6
238                 SCRATCH_MNT=/xfs1
239                 ;;
240             burst)
241                 TEST_DIR=/xfs
242                 TEST_DEV=/dev/hda3
243                 SCRATCH_DEV=/dev/hda7
244                 SCRATCH_MNT=/scratch
245                 ;;
246             lumpy)
247                 TEST_DEV=/dev/sdc5
248                 TEST_DIR=/mnt/scratch_0
249                 SCRATCH_DEV=/dev/sdc7
250                 SCRATCH_MNT=/mnt/scratch_2
251                 ;;
252             bongo)
253                 TEST_DEV=/dev/hda8
254                 TEST_DIR=/xfs1
255                 SCRATCH_DEV=/dev/hda9
256                 SCRATCH_MNT=/xfs2
257                 SCRATCH_LOGDEV=/dev/hda10
258                 SCRATCH_RTDEV=/dev/hda11
259                 ;;
260             surly)
261                 TEST_DEV=/dev/hda9
262                 TEST_DIR=/mnt/xfs1
263                 SCRATCH_DEV=/dev/hda8
264                 SCRATCH_MNT=/mnt/xfs0
265                 SCRATCH_LOGDEV=/dev/hda10
266                 TAPE_DEV=/dev/st0
267                 RMT_TAPE_DEV=fuzzy:/dev/st0
268                 RMT_IRIXTAPE_DEV=blub:/dev/tape
269                 RMT_TAPE_USER=guest
270                 ;;
271             permit)
272                 TEST_DEV=/dev/sdc1
273                 TEST_DIR=/mnt/xfs0
274                 SCRATCH_DEV=/dev/sdd1
275                 SCRATCH_MNT=/mnt/xfs1
276                 ;;
277             indra)
278                 TEST_DEV=/dev/sdb1
279                 TEST_DIR=/mnt/xfs0
280                 SCRATCH_DEV=/dev/sdb2
281                 SCRATCH_MNT=/mnt/xfs1
282                 ;;
283             usermode)
284                 TEST_DEV=/dev/ubd/1
285                 TEST_DIR=/mnt/test
286                 SCRATCH_DEV=/dev/ubd/2
287                 SCRATCH_MNT=/mnt/scratch
288                 SCRATCH_RTDEV=/dev/ubd/3
289                 SCRATCH_LOGDEV=/dev/ubd/4
290                 ;;
291             lite)
292                 TEST_DEV=/dev/sda1
293                 TEST_DIR=/mnt/sda1
294                 SCRATCH_DEV=/dev/sda2
295                 SCRATCH_MNT=/mnt/sda2
296                 SCRATCH_LOGDEV=/dev/sda3
297                 SCRATCH_RTDEV=/dev/sda4
298                 ;;
299             dmfnt2)
300                 TEST_DEV=/dev/sda6
301                 TEST_DIR=/mnt/test
302                 SCRATCH_DEV=/dev/sdc6
303                 SCRATCH_MNT=/mnt/scratch
304                 TAPE_DEV=/dev/st0
305                 RMT_TAPE_DEV=longhorn:/dev/tape
306                 # RMT_IRIXTAPE_DEV=longhorn:/dev/tape
307                 RMT_TAPE_USER=guest
308                 ;;
309             lab343)
310                 MODULAR=0
311                 EMAIL="hch@sgi.com"
312                 TEST_DEV=/dev/sdb1
313                 SCRATCH_DEV=/dev/sdb2
314                 SCRATCH_LOGDEV=/dev/sdb5
315                 SCRATCH_RTDEV=/dev/sdb6
316                 TEST_DIR=/qa/test
317                 SCRATCH_MNT=/qa/scratch
318                 ;;
319             icy)
320                 MODULAR=0
321                 EMAIL="ajones@sgi.com"
322                 TEST_DIR=/mnt/test
323                 TEST_DEV=/dev/sda3
324                 #TEST_LOGDEV=/dev/sda9
325                 #TEST_RTDEV=/dev/sda10
326                 SCRATCH_MNT=/mnt/scratch
327                 SCRATCH_DEV=/dev/sda5
328                 SCRATCH_LOGDEV=/dev/sda8
329                 SCRATCH_RTDEV=/dev/sda7
330                 TAPE_DEV=/dev/st0
331                 RMT_IRIXTAPE_DEV=snort:/dev/tape
332                 RMT_TAPE_DEV=icy:/dev/st0
333                 RMT_TAPE_USER=guest
334                 ;;
335             dribble)
336                 MODULAR=0
337                 EMAIL="ajones@sgi.com"
338                 TEST_DIR=/mnt/test
339                 TEST_DEV=/dev/dsk/dks0d2s0
340                 #TEST_LOGDEV=
341                 SCRATCH_MNT=/mnt/scratch
342                 SCRATCH_DEV=/dev/dsk/dks0d2s1
343                 #SCRATCH_LOGDEV=
344                 #SCRATCH_RTDEV=
345                 TAPE_DEV=/dev/tape
346                 RMT_TAPE_DEV=icy:/dev/st0
347                 RMT_TAPE_USER=guest
348                 RMT_IRIXTAPE_DEV=snort:/dev/tape        
349                 ;;
350             emu)
351                 MODULAR=0
352                 EMAIL="ajones@sgi.com"
353                 TEST_DIR=/mnt/test
354                 TEST_DEV=/dev/sdb1
355                 SCRATCH_MNT=/mnt/scratch
356                 SCRATCH_DEV=/dev/sdb2
357                 ;;
358
359             *)  
360                 echo "Error: need to define parameters for host $HOST"
361                 exit 1
362                 ;;
363         esac
364 }
365
366 if [ -f "$HOST_OPTIONS" ]; then
367     . "$HOST_OPTIONS"
368 else
369     known_hosts
370 fi
371
372 echo $TEST_DEV | grep -q ":" > /dev/null 2>&1
373 if [ ! -b "$TEST_DEV" -a "$?" != "0" ]
374 then
375     echo "common.config: Error: \$TEST_DEV ($TEST_DEV) is not a block device or a NFS filesystem"
376     exit 1
377 fi
378
379 if [ ! -d "$TEST_DIR" ]
380 then
381     echo "common.config: Error: \$TEST_DIR ($TEST_DIR) is not a directory"
382     exit 1
383 fi
384
385 echo $SCRATCH_DEV | grep -q ":" > /dev/null 2>&1
386 if [ ! -z "$SCRATCH_DEV" -a ! -b "$SCRATCH_DEV" -a "$?" != "0" ]
387 then
388     echo "common.config: Error: \$SCRATCH_DEV ($SCRATCH_DEV) is not a block device or a NFS filesystem"
389     exit 1
390 fi
391
392 if [ ! -z "$SCRATCH_MNT" -a ! -d "$SCRATCH_MNT" ]
393 then
394     echo "common.config: Error: \$SCRATCH_MNT ($SCRATCH_MNT) is not a directory"
395     exit 1
396 fi
397
398 _readlink()
399 {
400     if [ $# -ne 1 ]
401     then
402         echo "Usage: _readlink filename" 1>&2
403         exit 1
404     fi
405
406     perl -e "\$in=\"$1\";" -e '
407         $lnk = readlink($in);
408         if ($lnk =~ m!^/.*!) {
409           print "$lnk\n";
410         }
411         else {
412           chomp($dir = `dirname $in`);
413           print "$dir/$lnk\n";
414         }'
415 }
416
417 # if devfs is running expand the full /dev/.. pathname - this is what will be
418 # returned by utilities such as mount
419 [ -L "$TEST_DEV" ] && TEST_DEV=`_readlink $TEST_DEV`
420 [ -L "$SCRATCH_DEV" ] && SCRATCH_DEV=`_readlink $SCRATCH_DEV`
421 [ -L "$SCRATCH_LOGDEV" ] && SCRATCH_LOGDEV=`_readlink $SCRATCH_LOGDEV`
422 [ -L "$SCRATCH_RTDEV" ] && SCRATCH_RTDEV=`_readlink $SCRATCH_LOGDEV`
423
424 # make sure this script returns success
425 /bin/true